#include <stdio.h>

  /* Zadatak 3:
     (a) Napisite funkciju ciklicko_dno koja prima prirodni broj n i bazu b
         (pretpostavljamo da je  b >= 2). Funkcija treba vratiti najmanji
         prirodni broj ciji zapis u bazi b mozemo dobiti nekom ciklickom
         rotacijom znamenki u zapisu broja n u bazi b.
     (b) Napisite program koji prvo ucitava bazu b, a zatim ucitava niz
         prirodnih brojeva sve dok se ne ucita broj nula (ta nula nije clan
         niza, vec samo oznaka za kraj niza). Ako ucitani niz nije prazan,
         program treba ispisati onaj clan niza koji ima najvece ciklicko dno
         u bazi b i pripadno ciklicko dno. Iskoristite funkciju iz (a) cak
         i ako ju niste napisali!
     Strogo zabranjeno je koristenje bilo kakvih nizova!
  */

int ciklicko_dno(int n, int b)
{
    int min = n,      // minimum odmah inicijaliziramo na n.
        pot = 1,      // inicijalizacija najvise potencije baze u broju n
        br_znam = 1,  // inicijalizacija broja znamenki odn (ima bar jednu)
        broj,         // radni broj za znamenke i rotacije
        i;            // indeks petlje za rotacije

        /* najvisa potencija baze i broj znamenki. */
    broj = n;
    while (broj >= b) {  // broj ima barem dvije znamenke
        pot *= b ;       // povecaj potenciju baze
        ++br_znam;       // povecaj broj znamenki
        broj /= b;       // obrisi zadnju znamenku broja
    }

        /* Broj mogucih ciklickih rotacija za 1 mjesto (udesno) je bas
           jednak broju znamenki. Prvu (za 0 mjesta) vec imamo u n,
           i zato je min inicijalizran na n. Treba napraviti jos
           br_znam - 1 rotacija za po jedno mjesto udesno. */
    broj = n;
    for (i = 1; i < br_znam; ++i) {
        /* Rotacija znamenki udesno za jedno mjesto je:
           1. podijeli broj s b (mice sve znamenke udesno, bez zadnje)
           2. dodaj zadnju pomnozenu s pot (ide na prvo mjesto)! */
        broj = broj / b + (broj % b) * pot;
        if (broj < min) min = broj;
    }
    return min;
}

int main(void) {
    int b, n, dno, max_dno = 0, max_n;

        /* Citanje baze i sljedeceg broja. */
    printf("Upisi bazu i clanove niza (0 = kraj):\n");
    scanf("%d%d", &b, &n);

        /* Petlja za "prave" clanove niza <=> n != 0 (n je prirodan). */
    while (n != 0) {
            /* Obradi clan n = njegovo dno i provjera najveceg. */
        dno = ciklicko_dno(n, b);
        if (dno > max_dno) {
            max_dno = dno;
            max_n = n;
        }
            /* Ucitaj novi n = sljedeci clan ili kraj. */
        scanf("%d", &n);
    }

        /* Ispis ako niz nije prazan, test je preko max_dno > 0. */
    if (max_dno > 0)
        printf(" max_dno = %d, za clan = %d\n", max_dno, max_n);

    return 0;
}
